﻿using UnityEditor.Compilation;
using UnityEditor;
using UnityEngine;

namespace Playground.EditorInternal
{
    /// <summary>
    /// An access point for resources for the Playground Editors
    /// </summary>
    public static class PlaygroundEditorResources
    {
        static PlaygroundEditorResources()
        {
            var assemblyName = typeof(PlaygroundEditorResources).Assembly.FullName;
            var asmDefFile = CompilationPipeline.GetAssemblyDefinitionFilePathFromAssemblyReference(assemblyName.Remove(assemblyName.IndexOf(',')));
            RootPath = $"{asmDefFile.Remove(asmDefFile.LastIndexOf('/'))}/Editor Resources";
        }


        public static readonly string RootPath;


        public static T Load<T>( string path ) where T : Object => AssetDatabase.LoadAssetAtPath<T>($"{RootPath}/{path}");

        public static Texture2D LoadIcon( string path ) => Load<Texture2D>($"Icons/{path}.png");

        public static Texture2D LoadBackground( string path ) => Load<Texture2D>($"Backgrounds/{path}.png");
    }

}