﻿using UnityEngine;
using UnityEditor;
using droid.Editor.Windows;
namespace Playground.EditorInternal
{
    /// <summary>
    /// Toolbar MenuItems for all Playground Utilities
    /// </summary>
    public static class PlaygroundTools
    {
        #region Debugging
        [InitializeOnLoad]
        public static class ToggleDebugMenuItem
        {
            private const string MENU_NAME = "Tools/Playground/Debug/Enable";
            private static readonly string[] s_DebugSymbol = { "PLAYGROUND_DEBUG" };

            [MenuItem(MENU_NAME)]
            private static void ToggleAction()
            {
                PerformAction(!Menu.GetChecked(MENU_NAME));
            }

            public static void PerformAction( bool enabled )
            {
                Menu.SetChecked(MENU_NAME, enabled);
                if (!enabled)
                {
                    DefineSymbolsFunctionality.RemoveDefineSymbols(s_DebugSymbol);
                    Debug.Log($"DISABLED scripting define symbol: \"{s_DebugSymbol[0]}\"");
                }
                else
                {
                    DefineSymbolsFunctionality.AddDefineSymbols(s_DebugSymbol);
                    Debug.Log($"ENABLED scripting define symbol: \"{s_DebugSymbol[0]}\"");
                }
            }
        }
        #endregion
    }
}