﻿using UnityEditor;
using UnityEngine;

namespace Playground.EditorInternal
{
    [CustomEditor(typeof(LaserPointerMoveHack))]
    public class LaserPointerMoveHackEditor : Editor
    {
        SerializedProperty start, end;

        private void OnEnable()
        {
            start = serializedObject.FindProperty("start");
            end = serializedObject.FindProperty("end");
        }

        private void OnSceneGUI()
        {
            EditorGUI.BeginChangeCheck();
            start.vector3Value = Handles.DoPositionHandle(start.vector3Value, Quaternion.identity);
            end.vector3Value = Handles.DoPositionHandle(end.vector3Value, Quaternion.identity);
            if(EditorGUI.EndChangeCheck())
            {
                serializedObject.ApplyModifiedProperties();
            }
        }
    }
}