﻿namespace Playground
{
    /// <summary>
    /// <para>
    /// GROUP OPERATOR: AND - all conditions fulfilled
    /// </para>
    /// EXCEPTION:
    /// <para>When there are no conditions within, when all groups evaluate to true.</para>
    /// </summary>
    [System.Serializable]
    public sealed class ConditionGroup_AND : ConditionGroup
    {
        public override string Name => "AND-Group"; 
        public override bool Evaluate()
        {
            foreach (var condition in this)
                if (!condition.Evaluate()) return false;
            return true;
        }

        public override ConditionContainer GetDataContainer(ConditionValue conditionValue, bool inNestedGroupParam)
        {
            var container = base.GetDataContainer(conditionValue, inNestedGroupParam);
            var occ = container.CopyBasicValues<AndGroupConditionContainer>();

            occ = InsertMemberIdValues(occ);

            return occ;
        }
    }
}