﻿
namespace Playground
{
    /// <summary>
    /// <para>
    /// GROUP OPERATOR: OR - at least one fulfilled condition
    /// </para>
    /// EXCEPTION:
    /// <para>When there are no conditions within, when all groups evaluate to true.</para>
    /// </summary>
    [System.Serializable]
    [UnityEngine.HelpURL("https://justworksltd.gitlab.io/playground-docs/class_playground_1_1_condition_group__o_r.html")]
    public sealed class ConditionGroup_OR : ConditionGroup
    {
        public override string Name => "OR-Group"; 
        public override bool Evaluate()
        {
            if (ConditionsInGroup == 0) return true; //Default behaviour for all Condition groups
            foreach (var condition in this)
                if (condition.Evaluate())
                {
                    //UnityEngine.Debug.Log($"{condition} WAS TRUE");
                    return true;
                }
            return false;
        }

        public override ConditionContainer GetDataContainer(ConditionValue conditionValue, bool inNestedGroupParam)
        {
            var container = base.GetDataContainer(conditionValue, inNestedGroupParam);
            var occ = container.CopyBasicValues<OrGroupConditionContainer>();

            occ = InsertMemberIdValues(occ);

            return occ;
        }

    }
}