﻿namespace Playground
{
    /// <summary>
    /// <para>
    /// GROUP OPERATOR: XOR - one-and-only-one fulfilled condition within
    /// </para>
    /// EXCEPTION:
    /// <para>When there are no conditions within, when all groups evaluate to true.</para>
    /// </summary>
    [System.Serializable]
    public sealed class ConditionGroup_XOR : ConditionGroup
    {
        public override string Name => "Exclusive OR-Group"; 
        public override bool Evaluate()
        {
            if (ConditionsInGroup == 0) return true; //Default behaviour for all Condition groups
            int fulfilled = 0;
            foreach (var condition in this)
            {
                if (condition.Evaluate() && (fulfilled++ > 1))
                {
                    return false;
                }
            }
            return fulfilled == 1;
        }
    }
}