﻿using UnityEngine;

namespace Playground
{
    [System.Serializable]
    public sealed class PositionCondition : Condition<Transform>
    {
        //NOTE: with this here, the interface of Volume is
        //      practically speaking redundant 🤔🤔🤔🤔
        public enum VolumeMode
        {
            Cuboid,
            Sphere,
            Cylinder
        }
        public VolumeMode volumeMode;
        [SerializeField]
        public VolumeBase _volume;

        public override bool Evaluate()
        {
            var evaluation = _volume.InsideVolume(Context.transform.position);
            return evaluation;
        }

        public override ConditionContainer GetDataContainer(ConditionValue conditionValue, bool inNestedGroupParam)
        {
            var container = base.GetDataContainer(conditionValue, inNestedGroupParam);

            var pcc = container.CopyBasicValues<PositionConditionContainer>();
            pcc.volumeBase = _volume;
            pcc.volumeMode = volumeMode;

            return pcc;
        }
    }
}
