﻿using UnityEngine;
using droid.Runtime.Utilities.Sensors;
using droid.Runtime.Utilities.Misc;


namespace Playground
{
    [System.Serializable]
    public sealed class TouchCondition : Condition<Collider>
    {
        #region context_components
        private Collider _contextCollider; //NOTE: what about multi-collider objects - should be fixed by using sensors
        #endregion

        #region parameters
        #endregion

        private bool _isColliding;

        protected override void PreConfigure()
        {
            _contextCollider = Context.GetComponent<Collider>();
            NeodroidUtilities.RegisterCollisionTriggerCallbacksOnChildren<ChildCollider3DSensor, Collider, Collision>(_contextCollider, Context.transform, on_collision_enter_child: SetColliding, on_collision_exit_child: UnSetColliding);
        }

        void SetColliding(GameObject self, Collision collision)
        {
            if (collision.gameObject == Relative.gameObject)
                _isColliding = true;
        }
        void UnSetColliding(GameObject self, Collision collision)
        {
            if (collision.gameObject == Relative.gameObject)
                _isColliding = false;
        }

        public override bool Evaluate()
        {
            //TODO: turns out computepenetration only returns true when colliders 
            //      actually intercept each other, so this won't work :(
            return _isColliding;
        }


        public override ConditionContainer GetDataContainer(ConditionValue conditionValue, bool inNestedGroupParam)
        {
            var container = base.GetDataContainer(conditionValue, inNestedGroupParam);
            var tcc = container.CopyBasicValues<TouchConditionContainer>();

            return tcc;
        }
    }
}