﻿using System.Runtime.Serialization;
using UnityEngine;

namespace Playground.SaveSystem
{
    /// <summary>
    /// Used to serialize unity matrix4x4
    /// </summary>
    public sealed class Matrix4x4Surrogate : ISerializationSurrogate
    {
        public void GetObjectData(object obj, SerializationInfo info, StreamingContext context)
        {
            var matrix = (Matrix4x4)obj;

            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    info.AddValue(string.Format("{0},{1}", i, j), matrix[i, j]);
                }
            }
        }

        public object SetObjectData(object obj, SerializationInfo info, StreamingContext context, ISurrogateSelector selector)
        {
            var matrix = (Matrix4x4)obj;
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < 4; j++)
                {
                    matrix[i, j] = (float)info.GetValue(string.Format("{0},{1}", i, j), typeof(float));
                }
            }

            return matrix;
        }

    }
}

