﻿using System.Runtime.Serialization;
using UnityEngine;

namespace Playground.SaveSystem
{
    /// <summary>
    /// Used to serialize essential values of a unity engine quaternion
    /// </summary>
    public sealed class QuaternionSurrogate : ISerializationSurrogate
    {
        public void GetObjectData(object obj, SerializationInfo info, StreamingContext context)
        {
            var quaternion = (Quaternion)obj;

            for (int i = 0; i < 4; i++)
            {
                info.AddValue(string.Format("quaternion.{0}", i), quaternion[i]);
            }
        }


        public object SetObjectData(object obj, SerializationInfo info, StreamingContext context, ISurrogateSelector selector)
        {

            var quaternion = (Quaternion)obj;

            for (int i = 0; i < 4; i++)
            {
                quaternion[i] = (float)info.GetValue(string.Format("quaternion.{0}", i), typeof(float));
            }

            return quaternion;
        }

    }
}
