﻿using System.Runtime.Serialization;
using UnityEngine;

/* sources: 
 * ISerializationSurrogate: https://docs.microsoft.com/en-us/dotnet/api/system.runtime.serialization.surrogateselector?redirectedfrom=MSDN&view=netframework-4.7.2
 */
namespace Playground.SaveSystem
{
    /// <summary>
    /// Used to serialize unity vector2
    /// </summary>
    public sealed class Vector2Surrogate : ISerializationSurrogate
    {
        public void GetObjectData(object obj, SerializationInfo info, StreamingContext context)
        {
            var vector = (Vector2)obj;

            info.AddValue("x", vector.x);
            info.AddValue("y", vector.y);
        }

        public object SetObjectData(object obj, SerializationInfo info, StreamingContext context, ISurrogateSelector selector)
        {
            var vector = (Vector2)obj;

            vector.x = (float)info.GetValue("x", typeof(float));
            vector.y = (float)info.GetValue("y", typeof(float));

            return vector;
        }

    }

}