﻿using System.Collections.Generic;
using UnityEngine;

[System.Serializable]
public class SerializedHashSet<TValue> : HashSet<TValue>, ISerializationCallbackReceiver
{
    [SerializeField] private List<TValue> _values = new List<TValue>();
    
    // save the dictionary to lists
    public void OnBeforeSerialize()
    {
        _values.Clear();
        foreach (var value in this)
            _values.Add(value);
    }
    // load dictionary from lists
    public void OnAfterDeserialize()
    {
        Clear();
        for (int i = 0; i < _values.Count; i++)
            Add(_values[i]);
    }
}
