﻿using UnityEngine;
//TODO: move to its own assembly and maybe use singleton pattern instead of static to constant existence
namespace Playground.Tests
{
    public struct TestData
    {
        public SceneObject contextObject;
        public SceneObject relativeObject;
    }

    public static class TestUtility
    {

        public static TestData SetupDefaultScene()
        {
            // we don't use C# simplified object initialization as cubeSceneObject need struct reference for add component
            var testData = new TestData();
            testData.relativeObject = GameObject.CreatePrimitive(PrimitiveType.Plane).AddComponent<SceneObject>();
            testData.relativeObject.transform.localScale *= 2;
            testData.relativeObject.transform.position = Vector3.zero;
            testData.relativeObject.gameObject.name = "Plane";

            testData.contextObject = GameObject.CreatePrimitive(PrimitiveType.Cube).AddComponent<Rigidbody>().gameObject.AddComponent<SceneObject>();
            return testData;
        }

        public static bool EvaluateConditions(SceneObject sceneObject)
        {
            if (sceneObject.TerminatingConditions.ConditionsInGroup > 0 && sceneObject.TerminatingConditions.Evaluate())
                return false;
            return sceneObject.GoalConditions.Evaluate();
        }
    }
}

