﻿using UnityEngine;
using UnityEngine.UI;

namespace Playground.UI
{
    // TODO: Resolve bug where highlighted color remains on
    public class MenuButton : MonoBehaviour
    {
        protected Image image;
        protected Button button;
        protected float _lastTimeClicked;
        protected float _clickCooldown = 0.5f;
        public virtual void OnHover() { image.color = button.colors.highlightedColor; }
        public virtual void DeHover() { image.color = button.colors.normalColor; }

        public virtual void OnClick()
        {
            if (Time.timeSinceLevelLoad - _lastTimeClicked > _clickCooldown)
            {
                _lastTimeClicked = Time.timeSinceLevelLoad;
                button.onClick.Invoke();
            }
        }

        protected virtual void OnEnable()
        {
            image = GetComponent<Image>();
            button = GetComponent<Button>();
            image.color = button.colors.normalColor;
        }
    }
}
