﻿using UnityEngine;

namespace Playground.UI
{
    //Add a reference to this in GameManager?
    //TODO: rename
    public class LaserPointer : MonoBehaviour
    {
        //public System.Action<SceneObject> Select;
#pragma warning disable 0649
        [SerializeField] private Renderer laserRenderer;
        [SerializeField] private Material _laserMaterialSelectContext;
        [SerializeField] private Material _laserMaterialSelectRelative;
        [SerializeField] private Material _selectionMaterialSelectContext;
        [SerializeField] private Material _selectionMaterialSelectRelative;
#pragma warning restore 0649

        public Material ContextSelectionMaterial => _selectionMaterialSelectContext;
        public Material RelativeSelectionMaterial => _selectionMaterialSelectRelative;

#if UNITY_EDITOR
        private void Reset()
        {
            laserRenderer = transform.GetChild(0).GetChild(0).GetComponent<Renderer>();
        }
#endif
        private void Awake()
        {
            if (!laserRenderer)
                laserRenderer = transform.GetComponentInChildren<Renderer>();
            laserRenderer.sharedMaterial = _laserMaterialSelectContext;
            Mode = SelectionMode.Context;
        }
        public enum SelectionMode
        {
            None,
            Context,
            Relative
        }

        public SelectionMode Mode { get; private set; }
        internal void SetSelectionMode( SelectionMode selectionMode )
        {
            Mode = selectionMode;
            switch (Mode)
            {
                case SelectionMode.Context:
                laserRenderer.sharedMaterial = _laserMaterialSelectContext;
                break;
                case SelectionMode.Relative:
                laserRenderer.sharedMaterial = _laserMaterialSelectRelative;
                break;
            }
        }
        internal void Select( SceneObject selected )
        {
            switch (Mode)
            {
                case SelectionMode.Context:
                    GameManager.Instance.tabletMenu.SetContext(selected);
                break;
                case SelectionMode.Relative:
                    GameManager.Instance.tabletMenu.SetRelative(selected);
                break;
                case SelectionMode.None:
#if PLAYGROUND_DEBUG
                Debug.Log("LASER POINTER: Tried selecting something while mode was \"None\"");
#endif
                break;
                default:
#if PLAYGROUND_DEBUG
                Debug.Log("LASER POINTER: Tried selecting something while mode was \"<unknown enum value>\"");
#endif
                break;
            }
        }

        internal static void DefaultSelect( SceneObject selected )
        {
            selected.OnSetContext();
            GameManager.Instance.tabletMenu.SetContext(selected);
        }
    }
}