﻿using System.Collections.Generic;
using UnityEngine;
namespace Playground.UI
{
    public abstract class ConditionListMenu<TItem> : MonoBehaviour, IMenuItemContainer<TItem> where TItem : class
    {
        [SerializeField] protected MenuItem _menuItemPrefab;
        
        public new RectTransform transform => base.transform as RectTransform;

        protected List<MenuItem<TItem>> itemList = new List<MenuItem<TItem>>();

        public abstract void OnRecievedItemDrop( MenuItem<TItem> droppedItem );
        public void Clear()
        {
            foreach (var menuItem in itemList)
                Destroy(menuItem.gameObject); 

            itemList.Clear();
        }
        public virtual bool Remove(MenuItem<TItem> menuItem) => itemList.Remove(menuItem);
        public bool Contains(MenuItem<TItem> menuItem) => itemList.Contains(menuItem);

        public virtual void Redraw()
        {
            UnityEngine.UI.LayoutRebuilder.ForceRebuildLayoutImmediate(transform);
        }
    }
}
