﻿using System;
using UnityEngine;

namespace Playground.UI
{
    //TODO
    /// <summary>
    ///
    /// </summary>
    public class ConditionStateMenu : ConditionListMenu<Condition>, IMenuItemDropReciever<Type>
    {
#pragma warning disable 0649
        private ConditionGroup _group;
#pragma warning restore 0649
        public void SetTargetList( ConditionGroup target )
        {
            Clear();
            _group = target;
            itemList.Capacity = target.ConditionsInGroup;
            for (int i = 0; i < itemList.Capacity; i++)
            {
                var menuItemObject = Instantiate(_menuItemPrefab.gameObject, transform);
                menuItemObject.name = $"Item[{i}]_{_group[i].Name}";

                var menuItem = menuItemObject.GetComponent<ConditionMenuItem>();

                //TODO: Maybe create a MenuItemFactory or something like that,
                // as all items need to run a few instructions every time after fetching the component
                menuItem.SetRefferedItem(_group[i]);
                menuItem.Label.text = _group[i].Name;
                menuItem.container = this;

                itemList.Add(menuItem);
            }
            Redraw();
        }

        public override void OnRecievedItemDrop( MenuItem<Condition> droppedItem )
        {
            //QOL: Add items to the index where relative to where they're dropped

            if (itemList.Contains(droppedItem))
            {
                Debug.Log($"Dropped item: {droppedItem} back into its container.");
                Redraw();
            }
            else
            {
                Debug.Log($"Moving item: {droppedItem} from {droppedItem.container} to {this}.");
                droppedItem.container.Remove(droppedItem);
                droppedItem.container.Redraw();
                droppedItem.transform.SetParent(transform);
                droppedItem.container = this;
                itemList.Add(droppedItem); //TODO: add custom Add-function to interface, hide the underlying list.
                _group.AddCondition(droppedItem.RefferedItem);

                droppedItem.Label.text = $"#{itemList.Count} - {droppedItem.RefferedItem.Name}";

                Redraw();
            }
            GameManager.Instance.tabletMenu.SetEditingCondition(droppedItem.RefferedItem, droppedItem.Label.text);
        }

        /// <summary>
        /// Handle event where a typeMenuItem was dropped onto this container.
        /// </summary>
        /// <param name="droppedItem"></param>
        public void OnRecievedItemDrop( MenuItem<Type> droppedItem )
        {
            //TODO: Add Condition of Type to the current conditionGroup 'group'
            //      Instantiate a menuitem of with condition of type

            var contextObject = _group.Context;
            var itemCondition = (Condition)_group.Context.gameObject.AddComponent(droppedItem.RefferedItem);
            itemCondition.Initialize(contextObject);
            _group.AddCondition(itemCondition);

            var menuItemGameObject = Instantiate(_menuItemPrefab.gameObject, transform);
            menuItemGameObject.name = $"Item[{itemList.Count}]_{itemCondition.Name}";

            var menuItem = menuItemGameObject.GetComponent<ConditionMenuItem>();
            menuItem.SetRefferedItem(itemCondition);
            menuItem.Label.text = $"#{itemList.Count} - {itemCondition.Name}";
            menuItem.container = this;
            menuItem.onClick.AddListener(
                () => GameManager.Instance.tabletMenu.SetEditingCondition(menuItem.RefferedItem, menuItem.Label.text)
            );
            menuItem.onClick.Invoke();

            itemList.Add(menuItem);
            Redraw();
            droppedItem.container.Redraw();
        }

        public override bool Remove( MenuItem<Condition> menuItem )
        {
            if(base.Remove(menuItem))
            {
                _group.RemoveCondition(menuItem.RefferedItem);
                return true;
            }
            return false;
        }
    }
}
