﻿namespace Playground.UI
{
    public interface IMenuItemContainer<TItem> : IMenuItemDropReciever<TItem> where TItem : class
    {
        /// <summary>
        /// Remove the menuItem from the container
        /// </summary>
        /// <param name="menuItem"></param>
        /// <returns>result of removal, true when removed, false when unsuccessful</returns>
        bool Remove(MenuItem<TItem> menuItem);

        /// <summary>
        /// Check if a menuItem is in the container
        /// </summary>
        /// <param name="menuItem"></param>
        /// <returns>true when container holds menuItem, false otherwise</returns>
        bool Contains(MenuItem<TItem> menuItem);

        /// <summary>
        /// Clear the contained items out of the container
        /// </summary>
        void Clear();

        /// <summary>
        /// Force a redraw of the container
        /// </summary>
        void Redraw();
    }
}