﻿using UnityEngine.UI;
using UnityEngine;
using System;

namespace Playground.UI
{
    public class StatusMenu : MonoBehaviour
    {
       
        private Text   _txtStatus;
        System.Text.StringBuilder statusStringBuilder; // for more performant string combinating
        // Start is called before the first frame update
        void Start()
        {
            statusStringBuilder = new System.Text.StringBuilder(500);
            _txtStatus =            transform.Find("txtStatus").GetComponent<Text>();

            if (GameManager.Instance.actorExist)
            {
                Button btnTraining = transform.Find("btnStartTraining")?.GetComponent<Button>();
                Text txtTraining = btnTraining?.GetComponentInChildren<Text>();
                if (btnTraining == null || txtTraining == null)
                {
                    Debug.LogError("StatusMenu unable to find its buttons. Were they renamed or moved?");
                    return;
                }
                btnTraining.interactable = true;
                txtTraining.text = "Start AI training";
            }
        }

        // Update is called once per frame
        void Update()
        {
            // TODO: Optimize. Too much allocation. Preallocate size. 
            statusStringBuilder.Remove(0, statusStringBuilder.Length);
            statusStringBuilder.Append("SceneObjects: ");
            statusStringBuilder.Append(GameManager.Instance.sceneObjectsCount);
            statusStringBuilder.AppendLine();
            statusStringBuilder.Append("Objects in goal state: ");
            statusStringBuilder.Append(GameManager.Instance.goalCount);
            statusStringBuilder.AppendLine();
            statusStringBuilder.Append("Objects in terminating state: ");
            statusStringBuilder.Append(GameManager.Instance.terminatingCount);

            _txtStatus.text = statusStringBuilder.ToString();
        }

        [ContextMenu("Reset scene")]
        public void ResetScene()
        {
            GameManager.Instance.ReloadScene();
        }

        [ContextMenu("Reset conditions")]
        public void ResetCondtions()
        {
            GameManager.Instance.RemoveAllConditions();
        }

        [ContextMenu("Save Conditions")]
        public void SaveCondtions()
        {
            // TODO: Call saving of conditions once merged with 'monobehaviour-save' branch.
            throw new NotImplementedException("Saving of conditions are not yet implemented.");
        }

        [ContextMenu("Start AI training")]
        public void StartAITraining()
        {
            GameManager.Instance.StartTraining();
        }

    }
}