﻿using UnityEngine;

namespace Playground.UI
{
    /// <summary>
    /// Central access point for all tablet menu submenus.
    /// Ensures consistency in selection and information displayed
    /// </summary>
    public class TabletMenu : MonoBehaviour
    {
#pragma warning disable 0649
        [SerializeField] private StatusMenu _statusMenu;
        [SerializeField] private ConditionEditorMenu _conditionEditorMenu;
        [SerializeField] private SceneObjectContextMenu _contextMenu;
#pragma warning restore 0649

        public void SetContext( SceneObject newContext )
        {
            _contextMenu.SetContext(newContext);
            _conditionEditorMenu.Clear();
        }
        public void SetRelative( SceneObject newRelative )
        {
            _conditionEditorMenu.SetRelative(newRelative);
        }
        public void SetEditingCondition( Condition selectedCondition, string label )
        {
            _conditionEditorMenu.SetTarget(selectedCondition, label);
        }
    }
}