﻿using UnityEngine;
namespace Playground.UI
{
    public class UIColliderScalerVR : MonoBehaviour
    {
        [SerializeField] private BoxCollider _collider;
        [SerializeField] private RectTransform _rectTransform;

#if UNITY_EDITOR
        private void Reset()
        {
            _collider = GetComponent<BoxCollider>();
            if (!_collider)
                _collider = gameObject.AddComponent<BoxCollider>();
            _rectTransform = GetComponent<RectTransform>();
            ScaleCollider();
        }

        private void OnValidate() => ScaleCollider();
#endif

        public void ScaleCollider()
        {
            _collider.center = new Vector3(
                (0.5f - _rectTransform.pivot.x) * _rectTransform.rect.width,
                (0.5f - _rectTransform.pivot.y) * _rectTransform.rect.height
            );

            _collider.size = new Vector3(_rectTransform.rect.width, _rectTransform.rect.height, 1);
        }
    }
}