﻿using UnityEngine;

/// <summary>
/// A hack implemented to emulate VR-controller movement in order to use the laser pointer outside of VR -purely for testing purposes
/// <img src="media/Gifs/UI/laserpointer_emulate.gif"></img>
/// </summary>
public class LaserPointerMoveHack : MonoBehaviour
{
    public Vector3 start, end;
    public float timeScale = 1;

#if UNITY_EDITOR
    private void Reset()
    {
        start = transform.position + Vector3.right * transform.localScale.magnitude;
        end = transform.position + Vector3.left * transform.localScale.magnitude;
    }
    private void OnDrawGizmos()
    {
        Gizmos.color = Color.blue;
        Gizmos.DrawLine(start, end);
        Gizmos.color = Color.green;
        Gizmos.DrawCube(start, Vector3.one * UnityEditor.HandleUtility.GetHandleSize(start) * 0.1f);

        Gizmos.color = Color.red;
        Gizmos.DrawCube(end, Vector3.one * UnityEditor.HandleUtility.GetHandleSize(end) * 0.1f);
    }
#endif

    float t;
    private void Update()
    {
        transform.position = Vector3.Lerp(start, end, t);
        t += Time.deltaTime * 0.1f * timeScale;
        if (t > 1) t = 0;
    }
}
