﻿using UnityEngine;
namespace Playground.UI
{
    [ConditionEditor(typeof(VelocityCondition))]
    public class VelocityConditionEditor : ConditionEditor<VelocityCondition>
    {
        /*VectorWidget3D _widgetMaxValue3D;
        VectorWidget3D _widgetMinValue3D;*/
        SliderWidget2D _widgetMaxValue2D;
        SliderWidget2D _widgetMinValue2D;

        ValueHandle<float> _handleMaxValue;
        ValueHandle<float> _handleMinValue;

        protected override void BuildUI_3D()
        {
            /* CreateWidget(out _widgetMaxValue3D, setup: w => w.valueHandle = _handleMaxValue);
             CreateWidget(out _widgetMinValue3D, setup: w => w.valueHandle = _handleMinValue);
            */
            Debug.LogWarning("velocity 3d not implemented");
        }

        protected override void BuildUI_2D()
        {
            CreateWidget2D(out _widgetMaxValue2D, out _handleMaxValue, Condition.MaxVelocity);
            CreateWidget2D(out _widgetMinValue2D, out _handleMinValue, Condition.MinVelocity);
        }

        protected override void DestroyUI_3D()
        {
            //Destroy(_widgetMaxValue3D);
            //Destroy(_widgetMinValue3D);
        }
        protected override void DestroyUI_2D()
        {
            Destroy(_widgetMaxValue2D.gameObject);
            Destroy(_widgetMinValue2D.gameObject);
        }

        public override void OnPushChanges()
        {
            Condition.MaxVelocity = _handleMaxValue;
            Condition.MinVelocity = _handleMinValue;
        }

    }
}
