﻿using UnityEngine;
using UnityEngine.UI;

namespace Playground.UI
{
    [RequireComponent(typeof(Slider))]
    [AddComponentMenu("Playground/Widget 2D/Slider")]
    public class SliderWidget2D : Widget2D<float> 
    {
        public Slider slider;


#if UNITY_EDITOR
        protected override void Reset()
        {
            base.Reset();

            GetSlider();
        }
#endif
        private void Awake()
        {
            GetSlider();
            slider.onValueChanged.AddListener(_ => PropogatePushChanges());
        }
        private void GetSlider()
        {
            if (slider != null)
                return;

            slider = GetComponent<Slider>();
            if (slider == null)
            {
                Debug.LogError("slider widget failed to retrieve slider component");
            }
        }

        public override void SetInitialState() => slider.value = Value;

    }
}
