﻿using UnityEngine;
using UnityEngine.UI;

namespace Playground.UI
{
    [RequireComponent(typeof(Toggle)), AddComponentMenu("Playground/Widget 2D/Toggle")]
    public sealed class ToggleWidget2D : Widget2D<bool>
    {
        [SerializeField] private Toggle _toggle;
#if UNITY_EDITOR
        protected override void Reset()
        {
            base.Reset();
            _toggle = GetComponent<Toggle>();
        }
#endif

        private void Awake()
        {
            //Inject calls to our own interface
            _toggle.onValueChanged.AddListener(_ => PropogatePushChanges());
        }

        public override void SetInitialState() => _toggle.SetIsOnWithoutNotify(Value);
        public override void OnPushChanges() => Value = _toggle.isOn;

    }
}