﻿using UnityEngine;
using UnityEngine.UI;

namespace Playground.UI
{
    // TODO: discuss wether we should find a bettter way to edit a vector than 3 sliders
    [RequireComponent(typeof(Slider), typeof(Slider), typeof(Slider))]
    [AddComponentMenu("Playground/Widget 2D/Vector")]
    public class VectorWidget2D : Widget2D<Vector3>
    {
        public Slider[] sliders = new Slider[3];

        const int X=0, Y=1,Z=2;

#if UNITY_EDITOR
        protected override void Reset()
        {
            base.Reset();
            if(sliders.Length != 3 && !(sliders[X] || sliders[Y] || sliders[Z]))
            {
                var gotSliders = GetComponents<Slider>();
                if (gotSliders.Length < 3)
                {
                    Debug.LogError("there was not enough sliders on VectorWidget2D", this);
                }

                sliders[X] = gotSliders[X];
                sliders[Y] = gotSliders[Y];
                sliders[Z] = gotSliders[Z];
            }
        }
#endif

        public override void SetInitialState()
        {
            sliders[X].value = Value.x;
            sliders[Y].value = Value.y;
            sliders[Z].value = Value.z;
        }

        public override void OnPushChanges()
        {
            Value = new Vector3(
                sliders[X].value,
                sliders[Y].value,
                sliders[Z].value
            );
        }
        private void Awake()
        {
            //inject calls to our interface
            foreach (var slider in sliders)
                slider.onValueChanged.AddListener(_ => PropogatePushChanges()); //call directly to the base in order to propogate the event
        }
    }
}
