﻿using UnityEngine;
namespace Playground.UI
{
    [RequireComponent(typeof(LineRenderer)), AddComponentMenu("Playground/Widget 3D/Vector")]

    public class VectorWidget3D : WidgetVR<Vector3>
    {
#pragma warning disable 0649
        [SerializeField] private Material _activeLineMat, _inactiveLineMat;
        [SerializeField] private LineRenderer _lineRenderer;
#pragma warning restore 0649
#if UNITY_EDITOR
        protected override void Reset()
        {
            base.Reset();
            _lineRenderer = GetComponent<LineRenderer>();
            start = transform.Find("Start") ?? transform.GetChild(0);
            start.GetComponent<Widget>()._owner = this;
            end = transform.Find("End") ?? transform.GetChild(1);
            end.GetComponent<Widget>()._owner = this;
        }
#endif
        public Transform start, end;

        public override void SetInitialState()
        {
            //TODO
            throw new System.NotImplementedException();
        }
        protected override void OnConditionContextSet()
        {
            start.transform.position = Condition.Context.transform.position;
            end.transform.position = Condition.Context.transform.position;
        }

        public override void OnStartUpdate()
        {
            _lineRenderer.sharedMaterial = _activeLineMat;
            _lineRenderer.SetPosition(0, start.position);
            _lineRenderer.SetPosition(1, end.position);
        }
        public override void OnUpdateVisuals()
        {
            _lineRenderer.SetPosition(0, start.position);
            _lineRenderer.SetPosition(1, end.position);
        }

        public override void OnStopUpdate()
        {
            _lineRenderer.sharedMaterial = _inactiveLineMat;
        }
        public override void OnPushChanges()
        {
            //TODO: Use Relative where it should be used
            Value = Condition.RelativeVector(end.position - start.position);
        }

    }
}