﻿Shader "Unlit/Color Transparent"
{
    Properties
    {
        _Color ("Color", Color) = (1, 1, 1, 1)
    }
    SubShader
    {
        Tags{ "Queue" = "Transparent" "IgnoreProjector" = "True" "RenderType" = "Transparent" }
        LOD 100
        CGINCLUDE

        #include "UnityCG.cginc"

        struct appdata
        {
            float4 vertex : POSITION;
            float3 normal : NORMAL;
        };

        struct v2f
        {
            float4 vertex : SV_POSITION;
        };

        fixed4 _Color;

        v2f vert(appdata v)
        {
            v2f o;
            o.vertex = UnityObjectToClipPos(v.vertex);
            return o;
        }

        fixed4 fragfront(v2f i) : SV_Target
        {
            return _Color;
        }

        fixed4 fragback(v2f i) : SV_Target
        {
            fixed4 c = _Color*0.5f;
            return c;
        }
        ENDCG
        Pass
        { 
            Cull Front
            ZWrite Off
            Blend SrcAlpha OneMinusSrcColor
            Lighting Off
            Fog{ Mode Off }

            CGPROGRAM
                #pragma vertex vert
                #pragma fragment fragback
            ENDCG
        }
        Pass 
        {
            Cull Back
            Blend SrcAlpha OneMinusSrcAlpha
            ZWrite Off
            Lighting Off
            Fog{ Mode Off }
        
            CGPROGRAM
                #pragma vertex vert
                #pragma fragment fragfront
            ENDCG
        }
    }
}
