﻿using NUnit.Framework;
using System.Collections;
using UnityEngine;

// NOTE: this was written to test alternative testing methods and syntactic approaches 
namespace Playground.Tests
{
    [TestFixture]
    public class RotationConditionTest
    {
        static TestData testData;
        private RotationCondition ParamToRotationCondition(float ad1, float ad2, float ad3, float tr1, float tr2, float tr3)
        {


            var condition = testData.contextObject.gameObject.AddComponent<RotationCondition>();
            condition.AllowedEulerDeviation = new Vector3(ad1, ad2, ad3);
            condition.TargetEulerRoation    = new Vector3(tr1, tr2, tr3);

            return condition;
        }

        // NOTE: params would break nuint it seems
        [Test]
        [TestCaseSource(typeof(RotationConditionData), "TestCases")]
        public bool Rotation_Tests(float ad1, float ad2, float ad3, float tr1, float tr2, float tr3)
        {

            testData = TestUtility.SetupDefaultScene();

            var condition = ParamToRotationCondition(ad1, ad2, ad3, tr1, tr2, tr3);

            // We need this to make linter happy even though we could have Assume for this...
            if (condition == null)
            {
                Debug.LogWarning("condition was null");
                return false;
            }
            if (testData.contextObject == null)
            {
                Debug.LogWarning("contextObject was null");
                return false;
            }
            if (testData.relativeObject == null)
            {
                Debug.LogWarning("relativeObject was null");
                return false;
            }

            testData.contextObject.transform.rotation = Quaternion.identity;
            //InitCondition(condition);

            condition.Initialize(testData.contextObject);
            condition.SetRelative(testData.relativeObject.GetComponent<Transform>());

            testData.contextObject.AddGoalCondition(condition);
            return TestUtility.EvaluateConditions(testData.contextObject);

            
        }
    }

    public class RotationConditionData
    {
        public static IEnumerable TestCases
        {
            get
            {
                yield return new TestCaseData(10f, 10f, 10f, 0f, 0f, 0f).Returns(true);
                yield return new TestCaseData(0f, 0f, 0f, 0f, 0f, 0f).Returns(true);
            }
        }
    }
}

